{
      .. 
  " : "
  .  , 2013.
   3.  .
    .
}
program Bank_3;
const Tmin = 1;  { min   } 
      Tmax = 9;  { max   }
var i, j, Tcp, sumT, count, K, L, PMax, P, NWait: integer;
    dT, M: real;
    ServiceTime: array[1..100] of integer;
{-----------------------------------------------
  START SERVICE
      
-----------------------------------------------}
procedure StartService;
var i: integer;
begin
  for i:=1 to K do
    if (NWait > 0) and (ServiceTime[i] = 0) then begin
      ServiceTime[i]:=Tmin+random(Tmax-Tmin+1);
      NWait:=NWait-1;
    end;
end;
{-----------------------------------------------
  DO SERVICE
       .
     .
-----------------------------------------------}
procedure DoService;
var i: integer;
begin
  for i:=1 to K do
    if ServiceTime[i] > 0 then
      ServiceTime[i]:=ServiceTime[i]-1; 
end;    
{-----------------------------------------------
       
  .
  : Lam -      
  :   
-----------------------------------------------}
function Poisson(Lam: integer): integer;
var s, r, z: real;
    k: integer;
begin
  r := exp(-Lam); s := r;
  k := 0;
  z := random;
  while s < z do begin
    k := k + 1;
    r := r * Lam / k;
    s := s + r; 
  end;
  Poisson := k; 
end;
{===============================================}
begin
  Pmax := 4;  { max    1  } 
  L := 48000; {     }
  M := 15;    {    }

  write('  : ');   
  readln(K); 
  count := 0;  
  NWait:=0;
  Tcp := (Tmax + Tmin) div 2;
  
  for i:=1 to L do begin
    P := Poisson(Pmax div 2); {   } 
    NWait:=NWait+P;   
    DoService;                {   }
    StartService;             {   } 
    sumT := 0;
    for j:=1 to K do sumT := sumT+ServiceTime[j];
    dT := (NWait*Tcp + sumT) / K;
    if dT > M then 
      count := count + 1;
  end; 
  writeln(' "" : ', count/L:6:2);
end.
