{
      .. 
  " : "
  .  , 2013.
   6.   Delphi.
  - .
}
{$APPTYPE CONSOLE}
program Bank_6;
uses Windows;
const
  Tmin = 1;  { min   } 
  Tmax = 9;  { max   }   
  Pmax = 4;  { max    1  }   
  MAXQUEUE = 100;
type
  TEventType = (evIn, evOut);
  TEvent = record
    time: real;
    evType: TEventType;
  end;
var
  K, Tcp, Pcp, NWait, NBusy: integer;
  symTime, Qcp, L: real;
  evQueue: array[1..MAXQUEUE] of TEvent;
  evQLength: integer;
  E: TEvent;
{-----------------------------------------------
  ADD TO QUEUE 
     ,   .
-----------------------------------------------}
procedure AddToQueue(E: TEvent);
var
  i, pos: integer;
begin
  if evQLength = MAXQUEUE then begin
    writeln('  !');
    Exit;
  end;
  pos := 1;
  while (pos <= evQLength) do
  begin
    if E.time < evQueue[pos].time then break;
    pos := pos + 1;
  end;  
  for i := evQLength downto pos do
    evQueue[i + 1] := evQueue[i];
  evQueue[pos] := E;
  evQLength := evQLength + 1;
end;
{-----------------------------------------------
  GET FROM QUEUE 
      .
-----------------------------------------------}
function GetFromQueue: TEvent;
var
  i: integer;
  E: TEvent;
begin
  if evQLength = 0 then begin
    E.time := 0;
    GetFromQueue := E;
    writeln('  !');
    Exit;
  end;
  GetFromQueue := evQueue[1];
  for i := 1 to evQLength - 1 do
    evQueue[i] := evQueue[i + 1];
  evQLength := evQLength - 1;
end;
{-----------------------------------------------
  FULL SERVICE TIME
     
  (   k)
-----------------------------------------------}
function FullServiceTime(Tcp, k: integer): real;
var
  z: real;
  i: integer;
begin
  z := 0;
  for i := 1 to k do  
    z := z - ln(random);
  FullServiceTime := z * Tcp / k;
end;
{-----------------------------------------------
  ARRIVE TIME
      .
-----------------------------------------------}
function ArriveTime: real;
begin
  ArriveTime := -ln(random) / Pcp;
end;
{-----------------------------------------------
  NEW CLIENT
      .
-----------------------------------------------}
procedure NewClient;
var E: TEvent;
begin
  E.evType := evIn;
  E.time := symTime + ArriveTime;
  AddToQueue(E);
end;
{-----------------------------------------------
  START SERVICE
     .
-----------------------------------------------}
procedure StartService;
var E: TEvent;
begin
  if (NWait > 0) and (NBusy < K) then begin
    NBusy := NBusy + 1;
    NWait := NWait - 1;
    E.evType := evOut;
    E.time := symTime + FullServiceTime(Tcp, 2); 
    AddToQueue(E);
  end;
end;
{-----------------------------------------------
  HANDLE EVENT
    
-----------------------------------------------}
procedure HandleEvent(E: TEvent);
begin
  symTime := E.time;
  case E.evType of
    evIn: 
      begin
        NewClient;
        NWait := NWait + 1;
      end;
    evOut:
      NBusy := NBusy - 1;
  end;
  StartService;
end;
{===============================================}
begin
  //       CP1251 (Win-1251).
  //       ,
  //       -    
  //        :
  //  -  "" -  : "Lucida Console".
  SetConsoleCP(1251);
  SetConsoleOutputCP(1251);

  Pcp := Pmax div 2;  {     1  }
  Tcp := (Tmax + Tmin) div 2; {    }
  L := 1000000; {     }

  NWait := 0;
  NBusy := 0;
  symTime := 0; 
  Qcp := 0;

  write('  : ');   
  readln(K); 

  NewClient;
  while symTime < L do begin
    E := GetFromQueue;
    Qcp:=Qcp+(E.Time - symTime)*NWait;
    HandleEvent(E);
  end;
  Qcp:= Qcp / symTime / K;
  writeln('  : ', Qcp:7:3);
  Readln;
end.